unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, VPEngine;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    procedure AppOnMessage(var Msg: TMsg; var Handled: boolean);
  public
    { Public declarations }
    hdoc : longint;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.AppOnMessage(var Msg: TMsg; var Handled: boolean);
begin
  if Msg.Message = VPE_DESTROYWINDOW then
    Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  VersionNumber : integer;
begin
  Application.OnMessage := AppOnMessage;

  hdoc := VpeOpenDoc(Handle, 'Mini Demo', ClientWidth, ClientHeight, VPE_EMBEDDED);

  VpeWriteBox(hdoc, 100, 100, 500, 200, '[PS 0 B C LtRed]Hello');
  VpeWriteBox(hdoc, 100, 250, 500, 350, '[''Times New Roman'' S 30 C Blue]World!');

  VpePreviewDoc(hdoc, nil, VPE_SHOW_NORMAL);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  MoveWindow(VpeWindowHandle(hdoc), 0, 0, ClientWidth, ClientHeight, false);
end;

end.
 